
from cxcore.manager import ManagerThread
from cxutil.utils import opts
from cxutil.UID import UID
from select import poll,POLLIN,POLLERR,POLLHUP,POLLPRI
from threading import Thread

import os

class fakeThread:
	def isAlive(self):
		return False

class monitor (ManagerThread):

	def post(self):
		self.fds = opts()
		# self.bus.put("dispatcher2",{"subscribe": self.bus.address, "group": "monitor"})
		(self.pread,self.pwrite) = os.pipe()



	def run(self):

		x = poll()
		x.register(self.pread)

		def ctl(fd):
			os.write(fd,"c")

		self.bus.put("dispatcher2",{"hook": ctl, "args": self.pwrite})
		self.bus.put("dispatcher2","register_socket")

		while True:
			m = x.poll(1000)
			for (fd,event) in m:
				if fd == self.pread:
					# wake up
					os.read(fd,1)
					# read fd
					addr = {}
					msg = self.bus.get(addr)
					if msg == "shutdown":
						return
					elif msg[0] == "register":
						self.log("debug","register %s with %s" % msg[1:])
						self.fds[msg[1]] = [msg[2],fakeThread()]
						x.register(msg[1], POLLIN | POLLPRI)
					elif msg[0] == "unregister":
						if msg[1] in self.fds.keys():
							x.unregister(msg[1])
							del self.fds[msg[1]]

				else:
					if fd in self.fds.keys():
						if not self.fds[fd][1].isAlive():
							self.fds[fd][1] = Thread(target = self.fds[fd][0],name = "monitor thread for fd %s" % (fd))
							self.fds[fd][1].start()
