"""
MIME transport
"""

# 	Copyright (c) 2005-2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from email import MIMEBase, MIMEMultipart
from base64 import b64encode

def encode(data,charset='utf-8',major_type='text',minor_type='plain'):
	'''
	Encode data into a MIME base64 message.
	'''

	message = MIMEBase.MIMEBase(major_type,minor_type)
	if major_type == 'text':
		message.set_charset(charset)

	message.set_payload(b64encode(data))

	return message

def multipart(data=[]):
	'''
	Create a multipart/mixed from a list of MIME messages
	'''

	message = MIMEMultipart.MIMEMultipart()
	for i in data:
		message.attach(i)

	return message
