"""
Proxy for external services
"""

# 	Copyright (c) 2005-2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import os
from popen2 import Popen3
from select import poll,POLLIN,POLLERR,POLLHUP

class service(object):
	'''
	Abstract service class
	'''
	
	def __call__(self,bus,addr,pipe,ctl,commands):
		return self.perform(bus,addr,pipe,ctl,commands)

	def perform(self,bus,addr,pipe,ctl,commands):
		'''
		'''
		pass

class proxy(service):
	'''
	'''
	path = None
	broken = None
	
	def __init__(self,path):
		service.__init__(self)
		self.path = path
		if not os.access(self.path,os.X_OK):
			self.broken = True
		else:
			self.broken = False

	def __call__(self,bus,addr,pipe,ctl,commands):

		if self.broken:
			return 255
		
		message = ""
		result = 0

		for command in commands:
			message += "%s\n" % (command)

		inst = Popen3([self.path,],True,-1)
		(i,k,l) = (inst.fromchild, inst.tochild, inst.childerr)
		pid = inst.pid
		
		k.write(message)
		k.close()

		x = poll()
		data = ""
		t = 100
		x.register(i)
		x.register(ctl)

		try:
			while True:
				m = x.poll(t)
				if not m:
					if data:
						bus.put(addr,
							{
								"data": data
							}
						)
						data = ""
				for (fd,event) in m:
					if event & POLLIN:
						a = os.read(fd,1)
						if fd == ctl:
							if a == 'c':
								os.kill(pid,2)
						if fd == i.fileno():
							data += a
					else:
						if data:
							bus.put(addr,
								{
									"data": data
								}
							)
							data = ""
						raise
		except:
			x.unregister(i)
			x.unregister(ctl)
		status = os.waitpid(pid,0)
		retval = 255
		if os.WIFEXITED(status[1]):
			retval = os.WEXITSTATUS(status[1])
		
		i.close()
		k.close()
		l.close()
		
		if retval != 0:
			result = 1
		
		return result

